<?php
namespace Inti\Google\Api;

use Zend\Expressive\Application;

/**
 * Class ConfigProvider
 *
 * @package Inti\Config\Api
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-google
 */
final class ConfigProvider
{
    /**
     * @return array
     */
    public function __invoke(): array
    {
        return [
            'dependencies' => $this->getDependencies(),
        ];
    }

    /**
     * @return array
     */
    public function getDependencies(): array
    {
        return [
            'invokables' => [
                Drive\DrivesHandler::class,
                Drive\FoldersHandler::class,
                Sheets\CreateHandler::class,
                Sheets\DeleteHandler::class,
                Sheets\ListHandler::class,
            ],

            'delegators' => [
                Application::class => [
                    ApplicationDelegator::class,
                ],
            ],
        ];
    }
}
