<?php
namespace Inti\Google;

use Google_Client;
use Psr\Container\ContainerInterface;

/**
 * Class ClientFactory
 *
 * @package Inti\Google
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-google
 */
final class ClientFactory
{
    /**
     * @param ContainerInterface $container
     * @return Google_Client
     * @throws \Google_Exception
     */
    public function __invoke(ContainerInterface $container): Google_Client
    {
        $config = $container->get('config')['google'] ?? [];

        $client = new Google_Client();
        $client->setApplicationName($config['application_name'] ?? '');
        $client->setAuthConfig($config['credentials'] ?? []);
        $client->setScopes($config['scopes'] ?? []);
        $client->setAccessType('offline');

        return $client;
    }
}
