<?php
namespace Inti\Google\Service\Drive;

use Google_Client;
use Google_Service_Drive;
use Psr\Container\ContainerInterface;

/**
 * Class DriveFactory
 *
 * @package Inti\Google\Service\Drive
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-google
 */
final class DriveFactory
{
    /**
     * @param ContainerInterface $container
     * @return Google_Service_Drive
     */
    public function __invoke(ContainerInterface $container): Google_Service_Drive
    {
        /** @var Google_Client $client */
        $client = $container->get(Google_Client::class);
        $client->setScopes(array_merge($client->getScopes(), [Google_Service_Drive::DRIVE]));

        return new Google_Service_Drive($client);
    }
}
