<?php
namespace Inti\Google\Service\Drive;

use Google_Service_Drive;
use Psr\Http\Message\ResponseInterface;
use Psr\Http\Message\ServerRequestInterface;
use Psr\Http\Server\MiddlewareInterface;
use Psr\Http\Server\RequestHandlerInterface;

/**
 * Class DriveMiddleware
 *
 * @package Inti\Google\Service\Drive
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-google
 */
final class DriveMiddleware implements MiddlewareInterface
{
    /** @var Google_Service_Drive */
    private $drive;

    /**
     * DriveMiddleware constructor.
     * @param Google_Service_Drive $drive
     */
    public function __construct(Google_Service_Drive $drive)
    {
        $this->drive = $drive;
    }

    /**
     * Process an incoming server request.
     *
     * Processes an incoming server request in order to produce a response.
     * If unable to produce the response itself, it may delegate to the provided
     * request handler to do so.
     *
     * @param ServerRequestInterface $request
     * @param RequestHandlerInterface $handler
     * @return ResponseInterface
     */
    public function process(ServerRequestInterface $request, RequestHandlerInterface $handler): ResponseInterface
    {
        return $handler->handle(
            $request->withAttribute('google-drive', $this->drive)
        );
    }
}
