<?php
namespace Inti\Google\Service\Drive;

use Google_Service_Drive;
use Psr\Container\ContainerInterface;
use Psr\Http\Server\MiddlewareInterface;

/**
 * Class DriveMiddlewareFactory
 *
 * @package Inti\Google\Service\Drive
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-google
 */
final class DriveMiddlewareFactory
{
    /**
     * @param ContainerInterface $container
     * @return MiddlewareInterface
     */
    public function __invoke(ContainerInterface $container): MiddlewareInterface
    {
        $drive = $container->get(Google_Service_Drive::class);
        return new DriveMiddleware($drive);
    }
}
