<?php
namespace Inti\Google\Service\Sheets;

use Google_Client;
use Google_Service_Sheets;
use Psr\Container\ContainerInterface;

/**
 * Class SheetsFactory
 *
 * @package Inti\Google\Service\Sheets
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-google
 */
final class SheetsFactory
{
    /**
     * @param ContainerInterface $container
     * @return Google_Service_Sheets
     */
    public function __invoke(ContainerInterface $container): Google_Service_Sheets
    {
        /** @var Google_Client $client */
        $client = $container->get(Google_Client::class);
        $client->setScopes(array_merge($client->getScopes(), [Google_Service_Sheets::SPREADSHEETS]));

        return new Google_Service_Sheets($client);
    }
}
