<?php
namespace Inti\Google\Service\Sheets;

use Google_Service_Sheets;
use Psr\Http\Message\ResponseInterface;
use Psr\Http\Message\ServerRequestInterface;
use Psr\Http\Server\MiddlewareInterface;
use Psr\Http\Server\RequestHandlerInterface;

/**
 * Class SheetsMiddleware
 *
 * @package Inti\Google\Service\Sheets
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-google
 */
final class SheetsMiddleware implements MiddlewareInterface
{
    /** @var Google_Service_Sheets */
    private $sheets;

    /**
     * SheetsMiddleware constructor.
     * @param Google_Service_Sheets $sheets
     */
    public function __construct(Google_Service_Sheets $sheets)
    {
        $this->sheets = $sheets;
    }

    /**
     * Process an incoming server request.
     *
     * Processes an incoming server request in order to produce a response.
     * If unable to produce the response itself, it may delegate to the provided
     * request handler to do so.
     *
     * @param ServerRequestInterface $request
     * @param RequestHandlerInterface $handler
     * @return ResponseInterface
     */
    public function process(ServerRequestInterface $request, RequestHandlerInterface $handler): ResponseInterface
    {
        return $handler->handle(
            $request->withAttribute('google-sheets', $this->sheets)
        );
    }
}
