<?php
namespace Inti\Google\Service\Sheets;

use Google_Service_Sheets;
use Psr\Container\ContainerInterface;
use Psr\Http\Server\MiddlewareInterface;

/**
 * Class SheetsMiddlewareFactory
 *
 * @package Inti\Google\Service\Sheets
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-google
 */
final class SheetsMiddlewareFactory
{
    /**
     * @param ContainerInterface $container
     * @return MiddlewareInterface
     */
    public function __invoke(ContainerInterface $container): MiddlewareInterface
    {
        $sheets = $container->get(Google_Service_Sheets::class);
        return new SheetsMiddleware($sheets);
    }
}
