<?php
namespace IntiTest\Google;

use Inti\Config\Service\ConfigManagerFactory;
use Inti\Container\ContainerFactory;
use Zend\Expressive\Application;
use Zend\Expressive\Router\Middleware\DispatchMiddleware;
use Zend\Expressive\Router\Middleware\RouteMiddleware;

require '../vendor/autoload.php';

ini_set('display_errors', 1);
error_reporting(E_ALL);

$configFactory = new ConfigManagerFactory();
/** @noinspection PhpFullyQualifiedNameUsageInspection */
$config = $configFactory([
    \Zend\Expressive\ConfigProvider::class,
    \Zend\Expressive\Router\ConfigProvider::class,
    \Zend\Expressive\Router\ZendRouter\ConfigProvider::class,

    \Inti\Config\ConfigProvider::class,
    \Inti\Google\ConfigProvider::class,

    \Inti\Config\Api\ConfigProvider::class,
    \Inti\Google\Api\ConfigProvider::class,
]);

$containerFactory = new ContainerFactory();
$container = $containerFactory($config);

/** @var Application $app */
$app = $container->get(Application::class);

$app->pipe(RouteMiddleware::class);
$app->pipe(DispatchMiddleware::class);

$app->run();
